version: '3.8'

services:
  agent:
    image: portainer/agent:{{ agent_version_tag | default('latest') }}
    environment:
      # REQUIRED: Should be equal to the service name prefixed by "tasks." when
      # deployed inside an overlay network
      AGENT_CLUSTER_ADDR: tasks.agent
      AGENT_PORT: 9001
      # LOG_LEVEL: debug
    volumes:
     # Needed to use hosts timezone
      - /etc/localtime:/etc/localtime:ro
      - /etc/timezone:/etc/timezone:ro
      - /var/run/docker.sock:/var/run/docker.sock
      - /var/lib/docker/volumes:/var/lib/docker/volumes
    networks:
      - traefik_proxy
    deploy:
      mode: global
      placement:
        constraints: [node.platform.os == linux]
      update_config:
        parallelism: 2
        delay: 10s
        order: start-first
        failure_action: rollback

  portainer:
      image: portainer/portainer-ce:{{ server_version_tag | default('latest') }}
      # Create password with this command:
      # htpasswd -nbB admin 'areallylongpassword' | cut -d ":" -f 2| sed -e s/\\$/\\$\\$/g
{% if admin_password is defined and admin_password != "" %}
      # Set admin password
      command: ["-H", "tcp://tasks.agent:9001", "--tlsskipverify", "--admin-password={{ admin_password | password_hash('bcrypt') | replace('$','$$') }}"]
{% else %}
      # Set container command: like this to let the admin user and password be set on first run
      command: ["-H", "tcp://tasks.agent:9001", "--tlsskipverify"]
{% endif %}
      # Use this if direct access to portainer dashboard is needed
      # ports:
      #  - "9000:9000"
      deploy:
        replicas: {{ environments[env].replicas | default('1') }}
        placement:
          constraints:
            - node.role == manager
        labels:
          - "traefik.enable=true"
          - "traefik.http.services.portainer.loadbalancer.server.port=9000"
          - "traefik.http.routers.portainer.service=portainer"
          - "traefik.http.routers.portainer.rule=Host(`{{ environments[env].service_hostname | mandatory }}`)"
          - "traefik.http.routers.portainer.entrypoints=https"
          - "traefik.http.routers.portainer.tls.certresolver=le"
        update_config:
          parallelism: {{ environments[env].update_config.parallelism | default('2') }}
          delay: {{ environments[env].update_config.delay | default('10s') }}
          order: start-first
          failure_action: rollback
        restart_policy:
          condition: on-failure
{% if enable_resources is defined and enable_resources == True %}
        resources:
          limits:
            memory: {{ environments[env].resources.limits.memory | default('128m') }}
          reservations:
            memory: {{ environments[env].resources.reservations.memory | default('64m') }}
{% endif %}
      volumes:
        - /etc/localtime:/etc/localtime:ro
        - /etc/timezone:/etc/timezone:ro
        - /var/run/docker.sock:/var/run/docker.sock
        - {{ environments[env].data_volume | default('/var/compose/infra/portainer/volumes/data') }}:/data
      networks:
        - traefik_proxy

networks:
  traefik_proxy:
    external:
      name: traefik_proxy
